import 'dart:convert';

import 'package:angel_framework/angel_framework.dart';
import 'package:routex_web/routex_web.dart';

class HttpServerRequestAngelImpl extends HttpServerRequestImpl {
  final RequestContext requestContext;
  final ResponseContext responseContext;

  HttpServerRequestAngelImpl(RequestContext request, this.responseContext)
      : this.requestContext = request,
        super(request.rawRequest);

  @override
  Map<String, dynamic> params() =>
      {}..addAll(requestContext.params)..addAll(requestContext.queryParameters);

  @override
  Map<String, dynamic> getBodyAsJson() => requestContext.bodyAsMap;

  Future<void> parseBody({Encoding encoding = utf8}) =>
      requestContext.parseBody();
}
