import 'package:angel_framework/angel_framework.dart'
    show ResponseContext, RequestContext;
import 'package:daggerito/daggerito.dart';
import 'package:routex_web/routex_web.dart';


class RoutingContextAngelImpl extends RoutingContextImpl {
  final _container;
  final RequestContext requestContext;

  RoutingContextAngelImpl(
    dynamic payload,
    RequestContext requestContext,
    ResponseContext responseContext,
    String mountPoint,
    Router router,
    HttpServerRequest request,
    Set<RouteImpl> routes,
  )   : _container = Container(
            component:
                _buildComponent(payload, requestContext, responseContext)),
        requestContext = requestContext,
        super(
          mountPoint,
          router,
          request,
          routes,
        ){
    requestContext.serviceParams['context'] = this;
  }

  @override
  void reroute(String path) {
    var responseContext = container.resolve<ResponseContext>(null,DependencyScope.app);
    responseContext.redirect(path);
    response().end(-1);
  }

  @override
  Container get container => _container;
}

class _AngelModule implements Module {
  final RequestContext requestContext;
  final ResponseContext responseContext;

  _AngelModule(this.requestContext, this.responseContext);

  @override
  void register(DependencyContainer container) {
    container.register(($) => requestContext);
    container.register(($) => responseContext);
  }
}

Component _buildComponent(
  dynamic payload,
  RequestContext requestContext,
  ResponseContext responseContext,
) {
  final modules = [
    _AngelModule(requestContext, responseContext),
  ];

  return payload != null && payload is Component
      ? SubComponent(
    payload,
          modules: modules,
        )
      : Component(modules: modules);
}
